summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author David Spencer <baildon.research@googlemail.com>2016-06-15 20:01:39 +0100
committer David Spencer <baildon.research@googlemail.com>2016-06-15 20:01:39 +0100
commit954a90d795153fa3885c9c3544ad04cb182fd407 (patch)
tree3b0056016815857af6a07a28f8058b92d6551d60
parent13f61521afc480fbb330036889c4af9e6210b439 (diff)
downloadtemplates-954a90d795153fa3885c9c3544ad04cb182fd407.tar.gz
templates-954a90d795153fa3885c9c3544ad04cb182fd407.tar.xz
haskell-template.SlackBuild: Added.
-rw-r--r--haskell-template.SlackBuild153
1 files changed, 153 insertions, 0 deletions
diff --git a/haskell-template.SlackBuild b/haskell-template.SlackBuild
new file mode 100644
index 0000000..8dac2d3
--- /dev/null
+++ b/haskell-template.SlackBuild
@@ -0,0 +1,153 @@
+#!/bin/sh
+
+# Slackware build script for <appname>
+
+# Copyright <year> <you> <where you live>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# |-----------------------------------------------------------------| #
+# REMOVE THIS ENTIRE BLOCK OF TEXT #
+#
+# A license is required, and we strongly suggest you use the above
+# BSD/MIT style license. We DO NOT accept "Public Domain" scripts.
+# Public domain is not valid in some countries, and no license is
+# worse than a "bad" license in those countries.
+#
+# This template is not meant to be a 'cut and paste' script to
+# enable any random user to make a working package. While
+# we're certainly not discouraging use of this template, if
+# you haven't manually gone through each step of the process
+# without the build script (typically as a normal user, as this
+# will reveal problems that you won't see as root), then there's
+# a good chance that something important is missing from your
+# submission.
+
+# When using this template script, please remove as many of
+# these unnecessary comments as possible. Commented code is
+# a good thing, but if it's obvious, there's no need to comment it.
+#
+# AGAIN, REMOVE THE COMMENTS IF THEY ARE NOT NEEDED - DON'T JUST
+# DELETE THIS BLOCK OF TEXT WITHOUT BOTHERING TO READ WHAT'S IN IT.
+#
+# |-----------------------------------------------------------------| #
+
+PRGNAM=haskell-appname # replace 'appname' with name of program
+VERSION=${VERSION:-1.4.1} # replace with version of program
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo} # the "_SBo" is required
+
+SRCNAM="$( echo $PRGNAM | cut -d- -f2- )"
+
+GHC_VERSION=$(ghc --numeric-version)
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+# Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo} # For consistency's sake, use this
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp} # Drop the package in /tmp
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Your application will probably need different configure flags;
+# these are provided as an example only.
+# Be sure to build only shared libraries unless there's some need for
+# static.
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+runghc Setup configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --libsubdir=ghc-${GHC_VERSION}/$SRCNAM-$VERSION \
+ --enable-shared \
+ --enable-library-profiling \
+ --docdir=/usr/doc/$PRGNAM-$VERSION
+
+# Compile the application and install it into the $PKG directory
+runghc Setup build
+runghc Setup haddock
+runghc Setup copy --destdir=$PKG
+runghc Setup register --gen-pkg-config
+
+PKGCONFD=/usr/lib${LIBDIRSUFFIX}/ghc-${GHC_VERSION}/package.conf.d
+PKGID=$( grep -E "^id: " $SRCNAM-$VERSION.conf | cut -d" " -f2 )
+mkdir -p $PKG/$PKGCONFD
+mv $SRCNAM-$VERSION.conf $PKG/$PKGCONFD/$PKGID.conf
+
+# Strip binaries and libraries
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Copy program documentation into the package
+# The included documentation varies from one application to another, so be sure
+# to adjust your script as needed
+# Also, include the SlackBuild script in the documentation directory
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ <documentation> \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# Copy the slack-desc (and a custom doinst.sh if necessary) into ./install
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+# Make the package; be sure to leave it in $OUTPUT
+# If package symlinks need to be created during install *before*
+# your custom contents of doinst.sh runs, then add the -p switch to
+# the makepkg command below -- see makepkg(8) for details
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}